module Md2site
  require "csv"

  #
  # ダウンロード一覧ファイルクラス
  class ListFile
    #
    # 初期化
    #
    # @param dir [String] 書込先ディレクトリ
    # @param mes [Messagex] Messagexクラスのインスタンス
    def initialize(dir, mes)
      @fname = File.join(dir, LIST_FILE)
      @mes = mes

      @mes.exc_file_open(@fname) { @csv = CSV.open(@fname, "w", { col_sep: "\t", headers: true }) }

      @csv.add_row([FIELD_FILENMAE, FIELD_DATETIMESTR, FIELD_UNIXTIME, FIELD_MD5])
    end

    #
    # 行追加
    #
    # @param row [Array<String>] 1行分のフィールドの配列
    # @return [void]
    def add(row)
      @csv.add_row(row)
    end

    #
    # ダウンロード一覧ファイルクローズ
    #
    # @return [void]
    def close
      @mes.exc_file_close(@fname) { @csv.close }
    end
  end
end
